module InterStrict where

-- import MonIdent
-- import MonError
import MonStateTrans

data AExp = Var Variable
          | Const Value
          | Plus AExp AExp
          | Let Variable AExp AExp
          deriving Show

type Value = Int
type Variable = String
type Env = [(Variable,Value)]

eval :: AExp -> Env -> M Value
eval (Var v) e = lookup1 v e
eval (Const c) e = return c
eval (Plus a1 a2) e = do
                       v1 <- eval a1 e  
                       v2 <- eval a2 e          
                       add v1 v2
eval (Let v a1 a2) e = do
                        x <- eval a1 e 
                        eval a2 (update e v x)

add :: Value -> Value -> M Value
add x y = do
           tick
           return (x+y) 

update :: Env -> Variable -> Value -> Env
update e v x = (v,x):e

lookup1 :: Variable -> Env -> M Value
lookup1 v' ((v,x):e) | v'==v  = return x
                     | otherwise = lookup1 v' e
lookup1 v' _ = fail v'


exp1 :: AExp
exp1 = Let "x" (Plus (Const 2) (Const 3)) 
               (Plus (Var "x") (Var "x"))

test :: AExp -> String
test a = display (eval a [])



