module MonError where

data E a = Error String | Ok a
         deriving Show

instance Monad E where
   return x = Ok x
   m >>= f  = case m of
               Error s -> Error s
               Ok x -> f x
   fail s = Error s

type M a = E a


tick :: E ()
tick = return ()

display :: Show a => E a -> String
display (Error s) = "Error: "++ s
display (Ok x)    = "Ok: " ++ show x

